#<profile4xi profile = "20" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "makeproxytype4xi.py">
#<abstract4xi abstract = "provides function MakeProxyType4Xi"/>
#<refer4xi reference = "managers.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
#<note4xi note = "function name starts with capital"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'MakeProxyType4Xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import weakref
    from traceback import format_exc         
except:
    pass
try:                 # rare ones 
    import array
    import queue          
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.managers import MakeProxyType
except:
    print("makeproxytype4xi.py *** failed in from multiprocessing.managers import MakeProxyType ***")
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from baseproxy4xi import BaseProxy4Xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>



# -------------------------------------------------------------------------------------------------
#<function4xi function = "MakeProxyType4Xi" usage = "
#   managers.py
#       AutoProxy
#           ProxyType = MakeProxyType('AutoProxy[%s]' % token.typeid, exposed)
#
#   arrayproxy4xi.py:
#       ArrayProxy4Xi = MakeProxyType4Xi('ArrayProxy4Xi', ('__len__', '__getitem__', '__setitem__','__sense__', '__reason__', '__ace__')) 
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def MakeProxyType4Xi(name, exposed, _cache={}):
    '''
    returns an proxy type whose methods are given by exposed
    '''
   
    # -----------------------------------------------------------------------------------------    
    # (Step 1/7)
    # -----------------------------------------------------------------------------------------        
    
    class2print = "MakeProxyType4Xi"
    method2print = "MakeProxyType4Xi"
    
    message2print = "{(Step 1/7a) started" + "; MakeProxyType4Xi-started: " + str(MakeProxyType4Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{(Step 1/7b) passed" + "; name-passed-to-MakeProxyType4Xi: " + str(name) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                  
        
    message2print = "{(Step 1/7c) passed" + "; exposed-passed-to-MakeProxyType4Xi: " + str(exposed) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
           
        
    message2print = "{(Step 1/7d) passed" + "; cache-passed-to-MakeProxyType4Xi: " + str(_cache) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
   
    # -----------------------------------------------------------------------------------------    
    # (Step 2/7)
    # -----------------------------------------------------------------------------------------        

    exposed2xi = tuple(exposed)
 
    message2print = "{(Step 2/7) set" + "; exposed2xi-set-by-MakeProxyType4Xi to: " + str(exposed2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
            
    # -----------------------------------------------------------------------------------------    
    # (Step 3/7)
    # -----------------------------------------------------------------------------------------        
        
    try:

        message2print = "{(Step 3/7a) returning" + "; cache-returning-by-MakeProxyType4Xi: " + str(_cache[(name, exposed2xi)]) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
       
        return _cache[(name, exposed2xi)]
    except KeyError:
    
        
        message2print = "{(Step 3/7b) hit" + "; name-hit-by-MakeProxyType4Xi: " + " *** " + str(name)  + " *** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        message2print = "{(Step 3/7c) hit" + "; exposed2xi-hit-by-MakeProxyType4Xi: " + " *** " + str(exposed2xi)  + " *** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        pass
        

    # -----------------------------------------------------------------------------------------    
    # (Step 4/7)
    # -----------------------------------------------------------------------------------------        
    dic2xi = {}

    message2print = "{(Step 4/7a) set" + "; dic2xi-set-by-MakeProxyType4Xi to: " + str(dic2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
             
        
    for meth2xi in exposed2xi:
    
        try: 
    
            message2print = "{(Step 4/7b) passing" + "; meth2xi-passing-to-exec-by-MakeProxyType4Xi: " + str(meth2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
        
            message2print = "{(Step 4/7c) passing" + "; dic2xi-passing-to-exec-by-MakeProxyType4Xi: " + str(dic2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
                            
                        
            exec('''def %s(self, *args, **kwds):
            return self._callmethod(%r, args, kwds)''' % (meth2xi, meth2xi), dic2xi)

            message2print = "{(Step 4/7d) performed" + "; exec-performed-by-MakeProxyType4Xi: " + str(exec) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
        except:
            message2print = "{(Step 4/7e) hit" + "; meth2xi-hit-by-MakeProxyType4Xi: " + " *** " + str(meth2xi)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                
                            
    # -----------------------------------------------------------------------------------------    
    # (Step 5/7)
    # -----------------------------------------------------------------------------------------        
   
    ProxyType2xi = type(name, (BaseProxy4Xi,), dic2xi)
  
    message2print = "{(Step 5/7a) set" + "; ProxyType2xi-set-by-MakeProxyType4Xi to: " + str(ProxyType2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
            
    
    ProxyType2xi._exposed_ = exposed2xi

    message2print = "{(Step 5/7b) set" + "; ProxyType2xi-exposed-set-by-MakeProxyType4Xi to: " + str(ProxyType2xi._exposed_)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
          
    
    # -----------------------------------------------------------------------------------------    
    # (Step 6/7)
    # -----------------------------------------------------------------------------------------        
        
    _cache[(name, exposed2xi)] = ProxyType2xi
    
    message2print = "{(Step 6/7) set" + "; cache-set-by-MakeProxyType4Xi to: " + str(_cache[(name, exposed2xi)])  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
             
    
    # -----------------------------------------------------------------------------------------    
    # (Step 7/7)
    # -----------------------------------------------------------------------------------------        
    message2print = "{(Step 7/7) returning" + "; ProxyType2xi-returning-by-MakeProxyType4Xi: " + str(ProxyType2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        
        
    return ProxyType2xi
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of makeproxytype4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>



